"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.blsVerify = void 0;
const utils_1 = require("./utils");
const bls12_381_1 = require("@noble/curves/bls12-381");
const blsVerify = async (primaryKey, signature, message) => {
    bls12_381_1.bls12_381.verifyShortSignature;
    const pk = typeof primaryKey === 'string' ? primaryKey : (0, utils_1.toHex)(primaryKey);
    const sig = typeof signature === 'string' ? signature : (0, utils_1.toHex)(signature);
    const msg = typeof message === 'string' ? message : (0, utils_1.toHex)(message);
    return bls12_381_1.bls12_381.verifyShortSignature(sig, msg, pk);
};
exports.blsVerify = blsVerify;
//# sourceMappingURL=index.js.map